# задействуем пакет cawt
package require cawt

# класс "отчётец в word"
oo::class create WordReport {
variable Options	;# натраиваемые опции

constructor {} {
	array set Options {}
	set Options(openOrders) {}
	set Options(closeOrders) {}
	set Options(header) "Торговый отчёт"
	set Options(screenshot) ""
	set Options(text) "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
}
destructor {
}
method Set { name value } {
	set Options($name) $value
}
method AddOpen { args } {
	lappend Options(openOrders) $args
}
method AddClose { args } {
	lappend Options(closeOrders) $args
}
method Publish {} {
	if { ! [ info exists ::MetaTrader ] } {
		parray Options
	}
}
# делаем методы публичными
export Set AddOpen AddClose Publish
}; #/class WordReport

# детализуем метод Report
oo::define WordReport method Publish {} {
	# будем перехватывать ошибки.. можно было try {..} catch {..} finally , но я по старинке - просто catch
	if { [ catch {
		# открывaем Word
		set word [ Word::OpenNew true ]
		# создаём новый пустой документ и получаем его id
		set doc [ Word::AddDocument $word ]
		# пишем заголовок и после него начинаем параграф
		# -2 - непосредственное значение из WdBuiltinStyle WdStyleHeading1
		set text [ Word::AppendText $doc $Options(header) 1 -2 ]
		# по центру
		# wdAlignParagraphCenter 1
		Word::SetRangeHorizontalAlignment $text 1
		# добавляем изображение
		if { $Options(screenshot)!="" && [ file readable [ file join mql5 files $Options(screenshot) ] ] } {
			# после нелишних проверок
			# имя файла для передачи в ворд - абсолютный с правильными разделителями
			set fileName [ file nativename [ file join [ pwd ] mql5 files $Options(screenshot) ] ]
			# берём указатель на конец текста
			set insertPoint [ Word::GetEndRange $doc ] 
			set imageId [ Word::InsertImage $insertPoint $fileName ]
		}
		# добавляем текст
		# -1 wdStyleNormal
		Word::AppendText $doc $Options(text) 1 -1
		# добавляем разрыв (аналог <br .>) 1.5 = полтора пункта; можно 1.5i - дюймы 1.5c - сантиметры
		Word::AppendParagraph $doc 1.5
		# добавляем таблицу с открытыми сделками
		if { [ llength $Options(openOrders) ] > 0 } {
			# заголовок
			# wdHeading2
			Word::AppendText $doc "Открытые ордера" 1 -3
			set insertPoint [ Word::GetEndRange $doc ] 
			set rows [ llength $Options(openOrders) ]
			set cols [ llength [ lindex $Options(openOrders) 0 ] ]
			set table [ Word::AddTable $insertPoint $rows $cols 1.5 ]
			# задаём рамки
			# 1 wdLineStyleSingle
			Word::SetTableBorderLineStyle $table 1
			# внешние толстые (2) внутри тоньше
			# 8 2 см WdLineWidth
			Word::SetTableBorderLineWidth  $table 8 2
			# пересылаем значения
			Word::SetMatrixValues $table $Options(openOrders)
			
		}
		# аналогично добавляем таблицу с закрытыми сделками
		if { [ llength $Options(closeOrders) ] > 0 } {
			# заголовок
			# wdHeading2
			Word::AppendText $doc "Закрытые за 24 часа" 1 -3
			set insertPoint [ Word::GetEndRange $doc ] 
			set rows [ llength $Options(closeOrders) ]
			set cols [ llength [ lindex $Options(closeOrders) 0 ] ]
			set table [ Word::AddTable $insertPoint $rows $cols 1.5 ]
			Word::SetTableBorderLineStyle $table 1
			Word::SetTableBorderLineWidth  $table 8 2
			Word::SetMatrixValues $table $Options(closeOrders)
		}
	} err ] } {
		if { ! [ info exists ::MetaTrader ] } {
			puts stderr "Cawt Error: $err"
		}
	}
	# завершили работу с Word, удаляем все COM объекты и связи
	Cawt::Destroy
}
# после переопределения метода, надо снова экспортировать
oo::define WordReport export Publish
